import * as chromeUtil from './chrome';
import { Chrome } from '../Chrome';
export interface options {
    maxActiveTabs?: number;
    flags?: chromeUtil.flags;
    defaultTimeout?: number;
}
export declare class ChromeHelper {
    private cdp;
    private isExpired;
    private activeTabs;
    private maxActiveTabs;
    private browserStartingPromise;
    private kill;
    private flags;
    private jobsComplete;
    private defaultTimeout;
    port: number;
    constructor(options: options);
    start(): Promise<Chrome>;
    onTabClose(targetId: string): void;
    quit(): Promise<void>;
    setExpired(): void;
    isIdle(): boolean;
    isFull(): boolean;
    getIsExpired(): boolean;
    getJobsComplete(): number;
}
